/*
**  dcam.h
**
**  Routines for converting a DCAM buffer to a Matlab RGB image
*/
#ifndef __DCAM
#define __DCAM

#include <stdio.h>
#include <time.h>
#include "image_buffer.h"

/* List supported DCAM formats */
enum { DCAM_RGB=1,DCAM_YUV444,DCAM_YUV422,DCAM_YUV411 };

void dcam_rgb_to_matlab(unsigned char *field_ptr,buffer *bf_image);
void dcam_yuv444_to_matlab(unsigned char *field_ptr,buffer *bf_image);
void dcam_yuv422_to_matlab(unsigned char *field_ptr,buffer *bf_image);
void dcam_yuv411_to_matlab(unsigned char *field_ptr,buffer *bf_image);

#endif /* __DCAM */
