%im1 is model, im2 is test
function [numcorrect,time,bestTrans,matches,matchesError, origError] = fastMatch(f1,f2,l1,l2)
	%h = [0.2 0.6 50];
	modelSize = [max(l1(1,:))-min(l1(1,:)) max(l1(2,:))-min(l1(2,:))] ;
	h = [0.4 .6 mean(modelSize)/10];
	time =toc;
	
	dists = getDist(f1,f2)';
	time(2) = toc-time;
	%[values,index] = sort(dists);
	[v1,i1] = min(dists);
	dists(sub2ind(size(dists),i1,1:length(i1)))=100000000;
	[v2,i2] = min(dists);
	values = [v1;v2];
	index = [i1;i2];
	time(3)=toc-sum(time);
	
	good = find((values(1,:)./values(2,:))<0.8);
		

	%[res.a,res.b,res.c,subset,ex] = findFastMatchNow(l1,l2(:,index(1,:)));
	[a,b,c,subset,ex2]=	findFastMatchNow(l1(:,good),l2(:,index(1,good)));
	time(4) = toc-sum(time);
	
	res.a = 10*ones(size(l1,2),size(l1,2));
	res.b = 10*ones(size(l1,2),size(l1,2));
	res.c = 10000*ones(size(l1,2),size(l1,2));
	res.a(good,good) = a;
	res.b(good,good) = b;
	res.c(good,good) = c;
	ex = zeros(4,size(l1,2));
	ex(:,good)= ex2;

	%theError = sum(exp(-(res.a/h(1)+res.b/h(2)+res.c/h(3))))';
	tmpError = exp(-(res.a/h(1)+res.b/h(2)+res.c/h(3)));

	theError=0;

	uniqueMatches = unique(index(1,:));
	
	for i=uniqueMatches
		where = find(index(1,:)==i);
		if length(where)>1
			theError = theError + max(tmpError(where,:));
		else 
			theError = theError+tmpError(where,:);
		end
	end
	theError= theError';

	[numcorrect,which] = max(theError);

	matches = index(1,:);
	matchesError = exp(-[res.a(:,which)/h(1) res.b(:,which)/h(2) res.c(:,which)/h(3)]);

	origError = [exp(res.a(:,which)) res.b(:,which) res.c(:,which)/100];


	bestTrans=[ex(:,which);which];
	time(5) = toc - sum(time);

function [rescaleError,reoriError,transError,subset,ex] = findFastMatchNow(L1,L2)

	usefast=0;
	ex=0;
	rescale =  L2(3,:)./L1(3,:);
	reori = mod(L2(4,:)-L1(4,:) + pi,2*pi)-pi;

	if usefast==1
		subset = randperm(size(L1,2));
		subset = subset(1:ceil(length(subset)/5));
		trans1 = rescale([1 1],subset).*[cos(reori(subset));-sin(reori(subset))];
		trans2 = rescale([1 1],subset).*[sin(reori(subset));cos(reori(subset))];
		shift =[sum(trans1.*L1([1 2],subset));sum(trans2.*L1([1 2],subset))] - L2([1 2],subset);
		transError = (trans1'*L1([1 2],:) - repmat(shift(1,:)',1,length(reori)) -repmat(L2(1,:),length(subset),1)).^2 + (trans2'*L1([1 2],:) - repmat(shift(2,:)',1,length(reori)) - repmat(L2(2,:),length(subset),1)).^2;

		reoriError = abs((mod(repmat(reori',1,length(subset)) - repmat(reori(subset),length(reori),1)+pi,2*pi))-pi);
		rescaleError = abs(log(rescale'*(1./rescale(subset))));

		transError= sqrt(transError');
	elseif usefast ==0
	
		trans1 = rescale([1 1],:).*[cos(reori);-sin(reori)];
		trans2 = rescale([1 1],:).*[sin(reori);cos(reori)];

		shift =[sum(trans1.*L1([1 2],:));sum(trans2.*L1([1 2],:))] - L2([1 2],:);
	
		transError = (trans1'*L1([1 2],:) - repmat(shift(1,:)',1,length(reori)) -repmat(L2(1,:),length(reori),1)).^2 + (trans2'*L1([1 2],:) - repmat(shift(2,:)',1,length(reori)) - repmat(L2(2,:),length(reori),1)).^2;
		


		reoriError = repmat(reori,length(reori),1);
		reoriError =abs((mod(reoriError-reoriError'+pi,2*pi)-pi));
		rescaleError = abs(log(rescale'*(1./rescale)));
		transError= sqrt(transError');
		ex = [rescale;reori;shift];
		
		subset = 1:size(L1,2);
	end
	
function dists = getDist(f1,f2)
%	dists = f1'*f2;
	dists = 2*512*512-2*f1'*f2;
	%dists = repmat(sum(f1.*f1)',1,size(f2,2)) -2 *f1'*f2 + repmat(sum(f2.*f2),size(f1,2),1);