%A not terribly sophisticated method for ranking training images. Basically, a binary similarity matrix for the images is computed, and then the best representative images from each connected component are given a higher ranking.
%INPUTS
%imageList(i).siftName is the name of a valid file with sift descriptors

function [ranking,score,initscore] = rankImages(imageList,maxRes,dists)
	%A flakey threshold to determine if two images actually match
	%Basically means that 10% of the features in the image agree on a common transformation between the images. 
	decentMatch = .10;
	%[junk1,junk2,dists] = findMatchingImages(imageList,imageList,[maxRes maxRes]);
	[dists] = selfMatching(imageList);

	%pairMatches(i,j)==1 means image i and j are suffieciently similar to 
	pairMatches = double(dists>decentMatch);
	pairMatches(sub2ind(size(pairMatches),1:size(pairMatches,1),1:size(pairMatches,1)))=0;


	lasti=size(pairMatches,1);
	%Goes through the similarity matrix, selects the image that has the most matches, removes that image and all the images it matches to from the list
	%This should be less totalitarian but I have no time to fix it
	for i=1:size(pairMatches,1)
		goodMatches = sum(pairMatches);
		[score(i),ranking(i)] = max(goodMatches);
		if score(i)==0
			lasti = i;
			break;
		end
		initscore(i) = sum(dists(:,ranking(i))>decentMatch)-1;
		elim = find(pairMatches(:,ranking(i))==1);
		pairMatches(ranking(i),elim) = 0;
		pairMatches(:,ranking(i)) =0;
		pairMatches(elim,:) = 0;
	end

	%For any images ranked or selected above, put in the list in the order returned by the webcrawler (i.e google image search)
	if lasti<size(pairMatches,1)
		pairMatches = dists>decentMatch;
		score(lasti:size(pairMatches,1)) = 0;
		thoseLeft = setdiff( 1:size(pairMatches,1),ranking(1:lasti-1));
		[values,index] = sort(sum(pairMatches(:,thoseLeft)),'descend');
		initscore(lasti:size(pairMatches,1)) = floor(values);
		ranking(lasti:size(pairMatches,1)) = thoseLeft(index);
	end
	if size(pairMatches,1)==1
		ranking =1;
		score =1;
		initscore=1;
	end

