%This is the training script that we used in MATLAB to do the web downloading, keypoint extraction, and training image ranking.

%trainpath is the directory where the web trainning directories are

p=pwd;
cd ../../WEB/webImages/;
webpath = pwd;
%system('python getImages.py');
cd(p);
maxRes = [500 1000]; %max [trainResolution, testResolution] 
noSift = 1; %if 1, don't compute sift because they have been done
trainpath = [webpath '/resultImages/'];

listFile = [webpath '/list.txt'];

% These were some previous values of the initialization parameters, commented and saved for reference
% %Runs the web crawler
% cd '~/Working/WEB/webImages/';
% system('python getImages.py');
% cd '~/Working/CLASSIFY/ImageMatching/';
% %This is the max resolution for a dimension for [trainingImages testImages]
% %This was instituted for speed purposes. 
% maxRes = [500 1000]; 
% noSift = 0; %if 1, don't compute sift because they have been done


% 
% %trainpath is where the training images are, in numbered directories
% trainpath = '~/Working/WEB/webImages/images/';
% 
% %This is the txt file with the list of objects
% listFile = '~/Working/WEB/webImages/list.txt'


%Finding directory names, which must be numeric
dircontent = dir(trainpath);
ndirs=1;
clear directories;
clear fileList
for i=1:length(dircontent)
	[num,isok] = str2num(dircontent(i).name);
	if dircontent(i).isdir==1 & isok~=0
		directories(ndirs).name = dircontent(i).name;
        dircontent(i).name
		directories(ndirs).num = num;
		ndirs = ndirs+1;
	end
end
[values,index] = sort([directories.num]);
directories = directories(index);

%Going through each directory and creating sift features for each image
%If this has already been done, this reads in the file structure
for i=1:length(directories)
	tmptrainpath = strcat(trainpath,directories(i).name,'/');
	tmpoutputpath = strcat(trainpath,directories(i).name,'/');
	mkdir(tmpoutputpath);
	fileList(i).list = writeSiftImages(tmptrainpath,tmpoutputpath,maxRes(1),'.jpg',0,noSift);
	i
	%fileList(i).list = readHomogenous(strcat(trainpath,directories(i).name,'/imageInfo.txt'),fileList(i).list);
end

%For each class i, we reorder the training images so that images that are consistent (ie. match) other training images are bumped up.
for i=1:length(fileList)
	
	[fileList(i).ranking,fileList(i).score,fileList(i).initscore] = rankImages(fileList(i).list,maxRes(1));
	%fileList(i)
	fileList(i).goodImages = fileList(i).ranking;
	
end

%Save all the data acquired during the training phase that will be later used in the test phase
save webtrain fileList maxRes listFile


