%function K=blob_dissimilarity(descl,descr,sc,mn)
%
% Compute normalised SSD dissimilarity matrix from two lists
% of blobs
% 
% DESCL Left  image decriptor  DxN
% DESCR Right image desciptor  DxN
% SC    Scalings for each dimension (has default)
% MN    Mean offset i.e. d=(l-r-mn)^2 (has default)
%
%Per-Erik Forssen, April 2006

function K=blob_dissimilarity(descl,descr,s,m)

if nargin<3,
  s=[168.5521 16.8813 9.5764  1.4119 0.8945 0.4519 0.0459 0.0163 0.0142];
end
if nargin<4,
  m=[0 -14.72 -9.4 0 0 0 0 0 0]';
end

Nl = size(descl,2);
Nr = size(descr,2);
K  = zeros(Nl,Nr);

%m=mean([descl descr],2);
%s=sqrt(mean(([descl descr]-m*ones(1,Nl+Nr)).^2,2));
%m
%s

for k=1:Nr,
  diff=descl-repmat(descr(:,k)+m,[1 Nl]);
  %K(:,k)=sum(diff.*diff,1);
  K(:,k)=1./s.^2*(diff.*diff);
end


if 0,
  descl=blob_descriptor(mvec1,pvec1);                             
  descr=blob_descriptor(mvec2,pvec2);
  rthr=100;
  cl1=cl1(r<rthr);
  cl2=cl2(r<rthr);
  r=r(r<rthr);
  desc1=descl(:,cl1);
  desc2=descr(:,cl2);
  diff=desc1-desc2;
  s=sqrt(mean(diff.^2,2))';
  m=mean(diff,2);  
end