%function nl=knn_stereo(kp1,kp2,x,y,K)
%
% Find K nearest neighbours in a list of
% stereo correspondences.
%
% KP1    Left  SIFT keypoints (y,x,s,phi) (only y,x used)
% KP2    Right SIFT keypoints
% X,Y    Position
% K      Number of nearest neighbours to
%        select. (default 3)
%
%Per-Erik Forssen, Aug 2006

function nl=knn_stereo(kp1,kp2,x,y,K)

if nargin<5,K=3;end

D2=   (kp1(2,:)-x).^2+(kp1(1,:)-y).^2;
D2=D2+(kp2(2,:)-x).^2+(kp2(1,:)-y).^2;

[dummy,ind]=sort(D2);

nl=ind(1:K);
