%function img=cropImage(img0,bbox,sc)
%
% Crop image to bounding box, and resize to
% smaller resolution.
%
% IMG   Full image
% BBOX  Bounding box struct
% SC    Scaling of bounding box
%
%Per-Erik Forssen, May 2007
function img=cropImage(img0,bb,sc)

max_res=1000; % Max dimension to save image in

if nargin<3,sc=1;end

[rows,cols,ndim]=size(img0);

centre=[bb.topLeft(1)+bb.botRight(1), bb.topLeft(2)+bb.botRight(2)]/2;

% Scale bounding box
bb.topLeft=(bb.topLeft-centre)*sc+centre;
bb.botRight=(bb.botRight-centre)*sc+centre;

% Round to integer coordinates
bb.topLeft=round(bb.topLeft);
bb.botRight=round(bb.botRight);

% Crop bbox to image size
bb.topLeft(1)  = max(1,bb.topLeft(1));
bb.topLeft(2)  = max(1,bb.topLeft(2));
bb.botRight(1) = min(rows,bb.botRight(1));
bb.botRight(2) = min(cols,bb.botRight(2));

% Crop image to bbox
img=img0(bb.topLeft(1):bb.botRight(1),bb.topLeft(2):bb.botRight(2),:);

% Sub-sample image
[rows,cols,ndim]=size(img);
if max(rows,cols)>max_res,
  if(rows>max_res) cols=cols*max_res/rows;rows=max_res;end
  if(cols>max_res) rows=rows*max_res/cols;cols=max_res;end  
  img=imresize(img,[rows cols],'bilinear');
end