function doRandomWalk(isInitRandWalk,logFile,planningPars,cameraPars,configPars)
% Do random walk
%
% isInitRandWalk - Is this an initial random walk?
% logFile - file handle of the mapping log file
%

fprintf('Random walk...\n');
powerbot('movebot',0,0);
initialPose = powerbot('getodom');

count = 0;
isSafe = false;
direction = 'x';

while count < 4 && ~isSafe
    doSlam(1,true,logFile);
    [ isSafe direction ] = randWalkSafetyCheck(planningPars,cameraPars,configPars,direction);
    count = count + 1;
end

if ~isSafe
    return;
end;

if isInitRandWalk
  % Initial walk, move slower
  %powerbot('movebot');
  powerbot('movebot',0.2,10);
else
  powerbot('movebot');
end;

newPose = initialPose
while norm(newPose(1:2)-initialPose(1:2)) < 0.1
    newPose = powerbot('getodom');
end;

speeds = powerbot('getspeeds');
while abs(speeds(1)) > 0.01 || abs(speeds(3)) > 0.01
%while(1)
  %fprintf('Speeds are %f, %f. Iteration %d.\n',speeds(1),speeds(3),iter);
  % Do SLAM once in a while if we're not turning too fast
  if abs(speeds(3)) < 0.5 %&& any(speeds>0.01)
    doSlam(1,true,logFile);
    
    randWalkSafetyCheck(planningPars,cameraPars,configPars);
  end;

  speeds = powerbot('getspeeds')
end
fprintf('Done\n');

