function doSlam(nTimes,mustSucceed,logFile)
% Perform Slam nTimes and log the readings.
%
% mustSucceed - Keep retrying until we get laser readings?
% logFile - file handle of mapping log file
%

LOG_MAPPING = false;

fprintf(1,'In do SLAM.\n');

crStr = sprintf('\n');
for i=1:nTimes
  odom = powerbot('getodom');
  if mustSucceed
    lRgs = [];
    while length(lRgs) ~= 361
    [lRgs lPts] = powerbot('getlaser');
    end;
  else
    [lRgs lPts] = powerbot('getlaser');
  end;
  
  if LOG_MAPPING
      %log odometry
      odomStr = sprintf('o %g %g %g\n',odom);
      fwrite(logFile,odomStr,'char');
   
      %log laser
      fwrite(logFile,'l ','char');
  
      if length(lRgs) > 0
        laserStr = sprintf('%g ',lRgs);
        fwrite(logFile,laserStr,'char');
      end;
      
      fwrite(logFile,crStr,'char');
  end;
    
  if length(odom) == 3 && length(lRgs) == 361
    performSlam('do_slam',odom,lRgs);
  end;
end;

