function [il,disp,objectImage obstacles] = getImages(tilt,isForObstacles,configPars,cameraPars)

    % Unpack parameters
    usingLaptop = configPars.usingLaptop;
    configFile = cameraPars.configFile;
    is16BitDisp = cameraPars.is16BitDisp;
    
    bpattern=0; % Bayer pattern 0 for BB-HICOL=40, 2 for BB-COL-40
    img=[];
    
    disp=[];
    objectImage = [];
    while(length(img)==0) 
      if usingLaptop
        % Sometimes the camera reads from an old buffer... call  
        % multiple times to make sure we get the most recent frame
        img=camera('getframe');
        img=camera('getframe');
        img=camera('getframe');
      else
        img=powerbot('getframe');
      end;
    end;
    [il,ir]=bayer2rgbstereo(img,0,bpattern,2);

    il_uint = uint8(il*255);
    ir_uint = uint8(ir*255);
    
%     % Do stereo processing  
    im=uint8(zeros(size(il)));
    im(:,:,1)=il_uint(:,:,2);
    im(:,:,2)=ir_uint(:,:,2);
    if is16BitDisp
      disp=triclops_stereo16(im,configFile);
    else
      disp=triclops_stereo(im,configFile);
    end;
    
    [rows,cols]=size(disp);
    
    il = imresize( il_uint, [rows cols], 'bicubic' );
    %ir = imresize( ir_uint, [rows cols], 'bicubic' );
    
    il=colour_rectify(il,configFile,1);
    %ir=colour_rectify(ir,configFile,0); % Right field=0
    
    %objectImage = segmentGround( il, disp, tilt, is16BitDisp );
    [objectImage obstacles]= segmentGround2(il,disp,tilt,isForObstacles,cameraPars,configPars);
    
