%function [pl,pr] = getLRPositions(disp,objects,sc);
%
% Get positions in left and right images
%
% DISP    Disparity image
% OBJECTS Array of object structs
% SC      Image scaling
%
%Per-Erik Forssen, May 2007

function [pl,pr] = getLRPositions(disp,objects,sc);

No=length(objects);

pl=zeros(2,No);
pr=zeros(2,No);

for k=1:No,
  pos=objects(k).centre;
  x=pos(2);y=pos(1);
  
  % Just pick disparity at position (should be robust avg.)
  d=double(disp(round(y),round(x)));
  if(d>251) d=0;end  % Fall back to infinity if invalid disparity

  prc=[y;x]*sc;      % Scale to full res.
  plc=prc-[0;sc*d];
        
  fprintf('Object %d: pos=[%d %d] d=%g\n',k,pos,d);
  pl(:,k)=plc;
  pr(:,k)=prc;  
end