%function h=plot_objnum(objects,fsz)
%
% Plot object numbers at centres 
%
% OBJECTS Array of object structs
% FSZ     Font size (default 10)
%
%Per-Erik Forssen, June 2003

function h=plot_objnum(objects,fsz)

if nargin<2,fsz=10;end

No=length(objects);
h=zeros(No,1);

for k=1:No,
  pos=objects(k).centre;
  h(k)=text(pos(2),pos(1),num2str(k));
  set(h(k),'FontSize',fsz);
  set(h(k),'HorizontalAlignment','center');
  set(h(k),'VerticalAlignment','middle');
end

if(nargout==0),clear h;end