%function [ isSafe objs nxtObjId nTotalPics coverageMap ]  = randWalkSafetyCheck(planningPars,cameraPars,configPars)
function isSafe = randWalkSafetyCheck(planningPars,cameraPars,configPars)

count = 0;
isSafe = false;
direction = 'x';

while count < 4 && ~isSafe
    
    doSlam(1,true);
    count = count + 1;
    isSafe = true;
    
    powerbot('setpos',0,-40);

    positionPars.oGrid = performSlam('get_map');
    positionPars.rPose = performSlam('get_curvecpos');
    positionPars.rGridPos = performSlam('get_curgridpos');

    [oGrid nNewObs newObstaclesMap] = addObstaclesToMap(false,0.5,positionPars,cameraPars,configPars);

    pos = positionPars.rPose(1:2);
    yaw = positionPars.rPose(3);

    dangerX = [ 0; 0.8 ];
    dangerY= [ -0.7; 0.7 ];

    [rows,cols]=size(newObstaclesMap);
    [x y] = meshgrid([1:cols]-positionPars.rGridPos(2),...
        [1:rows]-positionPars.rGridPos(1));
    x = x*.1;
    y = y*.1;
    xr = x*cos(yaw)  + y*sin(-yaw);
    yr = x*sin(yaw) + y*cos(yaw);

    dangerMap = double((xr>dangerX(1))&(xr<dangerX(2))&(yr>dangerY(1))&(yr<dangerY(2)));

    figure(44);
    colormap(gray(256));
    img = repmat(positionPars.oGrid,[1 1 3]);
    img(find(dangerMap)+rows*cols)=0;  % Draw dangerMap
    img(find(newObstaclesMap))=0;  % Draw visual obstacles
    imagesc(img);axis image
    hold on
    h=plot(positionPars.rGridPos(2),positionPars.rGridPos(1),'g+');
    set(h,'MarkerSize',15);

    if(sum(newObstaclesMap(:).*dangerMap(:))>0)

        fprintf(1,'A visual obstacle was inside danger region during random walk!\n');
        
        %[objs nxtObjId nTotalPics coverageMap] = exploreLocation(cameraPars,gazePars,mappingPars,configPars,ptu_lim,coverageMap);
        

        % Stop the robot's current motion
        powerbot('movebotTo',powerbot('getodom'));

        if direction == 'x'

            dangerMapRight = double((xr>dangerX(1))&(xr<dangerX(2))&(yr>0)&(yr<dangerY(2)));
            dangerMapLeft = double((xr>dangerX(1))&(xr<dangerX(2))&(yr>dangerY(1))&(yr<0));

            if(sum(newObstaclesMap(:).*dangerMapRight(:)) > sum(newObstaclesMap(:).*dangerMapLeft(:)))

                turnbot(90);
                direction = 'l';
            else
                turnbot(-90);
                direction = 'r';
            end;
        else
            if direction=='l'
                turnbot(90);
            else
                turnbot(-90);
            end;
        end;

        isSafe = false;
    end;
end;