%function [ isSafe objs nxtObjId nTotalPics coverageMap ]  = randWalkSafetyCheck(planningPars,cameraPars,configPars)
function min_dist = randWalkSafetyDistance(planningPars,cameraPars,configPars)

doSlam(1,true);

powerbot('setpos',0,-40);

positionPars.oGrid = performSlam('get_map');
positionPars.rPose = performSlam('get_curvecpos');
positionPars.rGridPos = performSlam('get_curgridpos');

[oGrid nNewObs newObstaclesMap] = addObstaclesToMap(false,0.5,positionPars,cameraPars,configPars);

pos = positionPars.rPose(1:2);
yaw = positionPars.rPose(3);

dangerX = [ 0; 2.0 ];
dangerY= [ -0.7; 0.7 ];

[rows,cols]=size(newObstaclesMap);
[x y] = meshgrid([1:cols]-positionPars.rGridPos(2),...
    [1:rows]-positionPars.rGridPos(1));
x = x*.1;
y = y*.1;
xr = x*cos(yaw)  + y*sin(-yaw);
yr = x*sin(yaw) + y*cos(yaw);

dangerMap = double((xr>dangerX(1))&(xr<dangerX(2))&(yr>dangerY(1))&(yr<dangerY(2)));

il=find(dangerMap.*newObstaclesMap);
dist_list=xr(il);


[min_dist,min_ind] = min(dist_list);
if ~isempty(min_dist)
    [minx,miny]=ind2sub(size(dangerMap),il(min_ind));
end

figure(44);
colormap(gray(256));
img = repmat(positionPars.oGrid,[1 1 3]);
img(find(dangerMap)+rows*cols)=0;  % Draw dangerMap
img(find(newObstaclesMap))=0;  % Draw visual obstacles
imagesc(img);axis image
hold on
h=plot(positionPars.rGridPos(2),positionPars.rGridPos(1),'g+');
set(h,'MarkerSize',15);
if ~isempty(min_dist)
    h2=plot(miny,minx,'r*');
    set(h2,'MarkerSize',15);
else
    min_dist=1e8;
end
