function [resultImage] = segmentGround( im, disp, tilt, is16BitDisp );

slope_slope = 5.0308e-04;
slope_intercept = 0.0869;

intercept_slope = -0.3470;
intercept_intercept = -7.6860;

[rows,cols,junk] = size(im);

if is16BitDisp
  resultImage = zeros(rows,cols,'uint16');
else
  resultImage = zeros(rows,cols,'uint8');
end;

intercept = intercept_slope * tilt + intercept_intercept;
slope = slope_slope * tilt + slope_intercept;

disp_predicted = repmat( slope*(1:rows)'+intercept,1,cols );

if is16BitDisp
  objIndices = find( disp < 65280 & disp > (disp_predicted + 2)*256 );
  resultImage( objIndices ) = 65535;
else
  objIndices = find( disp < 253 & disp > disp_predicted + 2 );
  resultImage( objIndices ) = 255;
end;
