function [oGrid nNewObs newObstaclesMap] = addObstaclesToMap(isInitRandomWalk,OBSTACLE_THRESHOLD,positionPars,cameraPars,configPars)
%
% Grab an image from the bumblebee and add visually-
% detected obstacles into the map
%

% Unpack parameters
oGrid = positionPars.oGrid;
rPose = positionPars.rPose;

tilt = -40;
powerbot('setpos',0,tilt);

% Get image and disparity
[img disp objMap obstacles] = getImages(tilt,true,configPars,cameraPars);

% % List of [row col] of every pixel in the image
% [imRows imCols] = size(disp);
% rowCols = [];
% for i=1:imRows-1
%     rowCols = [rowCols; ones(imCols,1)*i (1:imCols)'];
% end
% 
% % Get pixels in camera coordinates
% if is16BitDisp
%   pc = triclops_getXYZ16(rowCols,disp, configFile);
% else
%   pc = triclops_getXYZ(rowCols,disp, configFile);
% end;
% 
% tilt = tilt-tilt_offset;
% tiltRad = tilt * pi/180
% 
% % Matrix to rotate 3D coordinates from camera to robot frame
% Rx_cam = [1    0              0; 
%           0    cos(tiltRad)   -sin(tiltRad);
%           0    sin(tiltRad)   cos(tiltRad)];
% 
% % Find points that are above the ground plane
% nPix = imRows*imCols;
% obstacles = zeros(nPix,5); % Preallocate for efficiency
% pcSize = size(pc);
% nObs = 0;
% for i=1:pcSize(1)
%     THRESHOLD = 0.06-0.03*(rowCols(i,1)/240);
%     pt = pc(i,:);
%     val = pt(3);
%     if val ~= -1
%       %Translate object center to robot coordinates
%       yzx_r = Rx_cam*pt';
%       xyz_r = [yzx_r(3) -yzx_r(1) CAMERAHEIGHT-yzx_r(2)];
%       if xyz_r(3) > THRESHOLD 
%         nObs = nObs+1;
%         obstacles(nObs,:) = [rowCols(i,:) xyz_r];
%       end;
%     end;
% end;
% % Truncate to actual # of obstacles
% obstacles = obstacles(1:nObs,:);
% size(obstacles)
% 
% if DISPLAY
% %   % plot obstacles
% %   figure(1);
% %   image(img);
% %   im2 = img;
% %   im2(sub2ind(size(im2),[obstacles(:,1),ones(nObs(1),1)],[obstacles(:,2),ones(nObs(1),1)]))=255;
% %   %plot(obstacles(:,2),obstacles(:,1),'r.');
% %   image(im2);
% %   drawnow;
% end
% 
% 
% 
% obMap = zeros(imRows,imCols,'uint8');
% obMap(sub2ind(size(obMap),obstacles(:,1),obstacles(:,2)))=255;
% obMap = im2bw(obMap);
% rBlur = 5;
% rErode = 2;
% 
% obMap = imdilate(obMap,strel('disk',rBlur));
% obMap=imerode(obMap,strel('disk',rBlur+rErode));
% obMap = imdilate(obMap,strel('disk',rBlur+rErode));
% 
% if DISPLAY
%   figure(2);
%   im2 = img;
%   indices = find(obMap ~=0);
%   [rows cols] = ind2sub(size(obMap),indices);
%   nObs = size(rows);
%   im2(sub2ind(size(im2),[rows,ones(nObs(1),1)],[cols,ones(nObs(1),1)]))=255;
%   %plot(obstacles(:,2),obstacles(:,1),'r.');
%   image(im2);
%   drawnow;
% end

% Convert obstacle locations to global frame
yaw = rPose(3);
R_r = [cos(yaw), -sin(yaw); sin(yaw), cos(yaw)];
nObs = size(obstacles);
obstacles(:,3:4) = (R_r*obstacles(:,3:4)')';
for i=1:nObs(1)
    obstacles(i,3:4) = obstacles(i,3:4) + rPose(1:2);
end;


% Add new visual obstacles to the occupancy grid
obstacleCells = performSlam('get_gridpos_from_vecpos',obstacles(:,3:4));
gridSize = size(oGrid);

% Map of visually-detected obstacles
obstacleMap = im2bw(zeros(gridSize(1),gridSize(2)));
obstacleMap(sub2ind(gridSize,obstacleCells(:,1),obstacleCells(:,2)))=1;

if isInitRandomWalk
    newObstaclesMap = obstacleMap;
else
    % Map of laser-detected obstacles
    laserMap = ~im2bw(oGrid,OBSTACLE_THRESHOLD);
    % Dilate to account for some noise that may cause visually-detected objects
    % to have slightly different positions than the laser detected ones
    laserMap = imdilate(laserMap,strel('disk',1));

    % Visual obstacles not detected by laser
    newObstaclesMap = ~laserMap & obstacleMap;
end;

nNewObs = nnz(newObstaclesMap);
oGrid(newObstaclesMap)=100;

figure(5);colormap(gray(256));image(oGrid);

% Uncomment line below to permanently add obstacles to map
%performSlam('add_obstacles',obstacles);


