%
%  A script to gather data to calibrate the Powerbot's 3 cameras as well 
%  as the PTU and zoom settings. 
%

%addpath /faculty/perfo/matlab/firewire/
addpath ../../resources/PEImageGrabbing/
addpath ../stereoCode/

SAVE_IMAGES = 1;

%powerbot('connect','128.189.189.153',7003);
%powerbot('connect','lisa.ubcrobots.net',7001);
powerbot('connect','bart.ubcrobots.net',7001);

powerbot('setpos',0,0);

pos=powerbot('getpos');
fprintf('pan=%d tilt=%d\n',pos(1),pos(2));

bpattern=0; % Bayer pattern 0 for BB-HICOL=40, 2 for BB-COL-40

configFile = '../stereoCode/bb_id5020143.config';

figure(1);clf;

lim = powerbot('getlim');

panValues = 0;%[ -20: 10: 20 ];
tiltValues = -43;[ -45: 1 : -30 ];
numSamples = 1;

for pan=panValues
    for tilt = tiltValues
        
        powerbot('setpos',pan,tilt);
        
        state=powerbot('getpos');
        act_pan=state(1);
        act_tilt=state(2);
        
        for sample = 1:numSamples
          
          img=[];
          while(length(img)==0) img=powerbot('getframe');end
          [il,ir]=bayer2rgbstereo(img,0,bpattern,2);
                   
          % Do stereo processing  
          im=uint8(zeros(size(il)));
          im(:,:,1)=uint8(il(:,:,2)*255);
          im(:,:,2)=uint8(ir(:,:,2)*255);
          disp=triclops_stereo(im,configFile);
          
          % Rectify the colour images to remove lens distortion
%           [il_rect]=colour_rectify(uint8( il * 255 ),configFile,0);
%           [ir_rect]=colour_rectify(uint8( ir * 255 ),configFile,1);
          
          % Display results
%           figure(1);image([il_rect ir_rect]);axis image;
%           title(['current state: pan=' num2str(pan) ' tilt=' num2str(tilt)]);
%           
          figure(1);
          clf;
          title(['current state: pan=' num2str(pan) ' tilt=' num2str(tilt)]);
          subplot(2,1,1);
          image(il);

          subplot(2,1,2);
          image(disp);axis image;
          
          drawnow;
          %pause();

          % Save images if required
          if SAVE_IMAGES
              filename = sprintf( 'data/img_pan_%d_tilt_%d_sample_%d_left.png', pan, tilt, sample );
              imwrite( il, filename );

              filename = sprintf( 'data/img_pan_%d_tilt_%d_sample_%d_right.png', pan, tilt, sample );
              imwrite( ir, filename );
              
              filename = sprintf( 'data/img_pan_%d_tilt_%d_sample_%d_disp.png', pan, tilt, sample );
              imwrite( disp, filename );
          end;
          
        end;
    end;
end

powerbot('setpos',0,0);
powerbot('disconnect');