%
%  Test of matlab powerbot interface
%
%addpath /faculty/perfo/matlab/firewire/
addpath ../../resources/PEImageGrabbing/
addpath ../stereoCode/

%powerbot('connect','128.189.189.153',7003);
%powerbot('connect','lisa.ubcrobots.net',7001);
powerbot('connect','bart.ubcrobots.net',7001);

powerbot('setpos',0,0);

pos=powerbot('getpos');
fprintf('pan=%d tilt=%d\n',pos(1),pos(2));

bpattern=0; % Bayer pattern 0 for BB-HICOL=40, 2 for BB-COL-40

configFile = '../stereoCode/bb_id5020143.config';

figure(1);clf

for k=[0:6]*5.5,
  powerbot('setpos',k*2,k);
  img=[];
  while(length(img)==0) img=powerbot('getframe');end
  [il,ir]=bayer2rgbstereo(img,0,bpattern,2);
  il = uint8( il * 255 );
  ir = uint8( ir * 255 );
  [il]=colour_rectify(il,configFile,0);
  [ir]=colour_rectify(ir,configFile,1);
  figure(1);image([il ir]);axis image;
  state=powerbot('getpos');
  pan=state(1);
  tilt=state(2);
  title(['current state: pan=' num2str(pan) ' tilt=' num2str(tilt)])
  drawnow
end

powerbot('setpos',0,0);
powerbot('disconnect');