%
% A script to read the images produced by grabCalibrationData
% and do some simple depth processing
%

%addpath /faculty/perfo/matlab/firewire/
addpath ../../resources/PEImageGrabbing/
addpath ../stereoCode/

DISPLAY = 1;
DISPLAY_COLS = 0;
SAVE_RESULTS = 1;
SAVE_RECT = 1;

configFile = '../stereoCode/bb_id5020143.config';

% panValues = [ -20: 10: 20 ];
% tiltValues = [ -35: 5 : -10 ];
% numSamples = 3;

 panValues = 0;%[ -20: 10: 20 ];
 tiltValues = -43;%[ -45: 1 : -30 ];%[ -45: 1 : -30 ];
 numSamples = 1;%10;

% A relatively clean floor image, tilt -30
%  il = imread( 'data/img_pan_0.000000_tilt_-29.982800_sample_2_left.png' );
%  ir = imread( 'data/img_pan_0.000000_tilt_-29.982800_sample_2_right.png' );
%  disp = imread( 'data/img_pan_0.000000_tilt_-29.982800_sample_2_disp.png' );

% An image containing a large portion of wall
%  il = imread( 'data/img_pan_20.005699_tilt_-9.977140_sample_2_left.png' );
%  ir = imread( 'data/img_pan_20.005699_tilt_-9.977140_sample_2_right.png' );
%  disp = imread( 'data/img_pan_20.005699_tilt_-9.977140_sample_2_disp.png' );

%  % An image with desk and cart at the top
%  il = imread( 'data/img_pan_20.005699_tilt_-24.994301_sample_1_left.png' );
%  ir = imread( 'data/img_pan_20.005699_tilt_-24.994301_sample_1_right.png' );
%  disp = imread( 'data/img_pan_20.005699_tilt_-24.994301_sample_1_disp.png' );

% A mostly clean image with the cart on top
%  il = imread( 'data/img_pan_-20.005699_tilt_-29.982800_sample_2_left.png' );
%  ir = imread( 'data/img_pan_-20.005699_tilt_-29.982800_sample_2_right.png' );
%  disp = imread( 'data/img_pan_-20.005699_tilt_-29.982800_sample_2_disp.png' );

slope_slope = 5.0308e-04;
slope_intercept = 0.0869;

intercept_slope = -0.3470;
intercept_intercept = -7.6860;

plane_results = [];

for tilt = tiltValues
for pan=panValues
for sample = 1:numSamples

fprintf(1,'Tilt %d Pan %d, Sample %d.\n',tilt, pan, sample);

il = imread( sprintf('data/img_pan_%d_tilt_%d_sample_%d_left.png',pan,tilt,sample ));
ir = imread( sprintf('data/img_pan_%d_tilt_%d_sample_%d_right.png',pan,tilt,sample ));
disp = imread( sprintf('data/img_pan_%d_tilt_%d_sample_%d_disp.png',pan,tilt,sample ));

[rows,cols] = size(disp);

[il]=colour_rectify(il,configFile,0);
[ir]=colour_rectify(ir,configFile,1);
il = imresize( il, [rows cols], 'bicubic' );
ir = imresize( ir, [rows cols], 'bicubic' );
    
if SAVE_RECT
    imwrite(il, sprintf('data/img_pan_%d_tilt_%d_sample_%d_leftRect.png',pan,tilt,sample ),'PNG'),
    imwrite(ir, sprintf('data/img_pan_%d_tilt_%d_sample_%d_rightRect.png',pan,tilt,sample ),'PNG'),
end;

%  figure(1);
%  clf;
%  hold on;
%  subplot(2,1,1);
%  image([il(:,1:col-1,:) 255.*ones(rows,1,3) il(:,col+1:cols,:)]);
%  axis image;
%  subplot(2,1,2);
%  image([disp(:,1:col-1,:) 255.*ones(rows,1) disp(:,col+1:cols,:)]);
%  axis image;
%  title(sprintf('Pan %d, Tilt %d, Sample %d',pan,tilt,sample));
%  drawnow;

if DISPLAY || SAVE_RESULTS || DISPLAY_COLS
    
resultImage = zeros(rows,cols,3,'uint8');

for col = 1:cols%cols / 4 : 3 * cols / 4

    slope = [];
    result = [];
    x_eval = 1: rows;

    intercept = intercept_slope * tilt + intercept_intercept;
    slope = slope_slope * tilt + slope_intercept;

    if DISPLAY_COLS
        figure(2);
        clf;
        hold on;
        subplot(2,2,1);
        image([ir(:,1:col-1,:) 255.*ones(rows,1,3) ir(:,col+1:cols,:)]);
        axis image;
        subplot(2,2,2);
        image([disp(:,1:col-1,:) 255.*ones(rows,1) disp(:,col+1:cols,:)]);
        axis image;
        subplot(2,2,4);
        hold on;
        image(resultImage);
        subplot(2,2,3);
        hold on;

    end;

    for row = 1:rows
        %fprintf('row: %d, col: %d.\n',row,col);
        if disp(row,col) < 253
            
            disp_predicted = slope*row+intercept;

            %plot(row,disp_predicted,'r.');

            if disp(row,col) > disp_predicted + 2 
                                
                resultImage(row,col,:) = ir(row,col,:);
                
                if DISPLAY_COLS
                    subplot(2,2,4);
                    image(resultImage);
                    subplot(2,2,3);
                    plot(row,disp(row,col),'r.');
                end;
            else
                if DISPLAY_COLS
                    plot(row,disp(row,col),'b.');
                    
                end;
            end;

            result = [ result ; row disp(row,col) ];
        end;
    end;
    
    if ~isempty(result)

        %[slope intercept] = fitLine(result);

        plane_results = [ plane_results; tilt col slope intercept ];

%          figure(2);
%          hold on;
%          plot(result(:,1),result(:,2),'b.');
    end;    
    
    if DISPLAY_COLS && ~isempty(slope)
        
        plot(x_eval, slope*x_eval+intercept,'r');
    end;
        
end;

if DISPLAY

    figure(1);
    clf;
    hold on;
    subplot(2,2,1);
    image(ir);
    axis image;
    subplot(2,2,2);
    image(disp);
    axis image;
    subplot(2,2,3);
    hold on;
    image(resultImage);
    axis image;
    drawnow;
    pause();
end;

if SAVE_RESULTS
    imwrite( resultImage, sprintf('results/img_pan_%d_tilt_%d_sample_%d_object.png',pan,tilt,sample),'PNG');
end;
    
end;

end;
end;
end;

save processCalibrationData_final.mat;

% This code plots all of the slope and intercept values over the entire
% image set.
% figure(4);
% hold on;
% subplot(2,1,1);
% hold on;
% title('Slope vs Tilt Values','FontSize',14);
% plot(plane_results(:,1),plane_results(:,3),'b.');
% 
% subplot(2,1,2);
% hold on;
% plot(plane_results(:,1),plane_results(:,4),'b.');
% title('Intercept vs Tilt Values','FontSize',14);

slope_result = [];
intercept_result = [];

for tilt = tiltValues

    mean_res = median(plane_results(find(plane_results(:,1)==tilt),:));

    slope_result = [ slope_result; tilt mean_res(3) ];
    intercept_result = [ intercept_result; tilt mean_res(4) ];

    figure(3);
    hold on;
    subplot(2,1,1);
    hold on;
    plot(tilt,mean_res(3),'b.');
    title('Slope vs Tilt Values','FontSize',14);
    
    subplot(2,1,2);
    hold on;
    plot(tilt,mean_res(4),'b.');
    title('Intercept vs Tilt Values','FontSize',14);

end;


x_eval=-45:0.1:-30;

[slope intercept] = fitLine( slope_result );
figure(3);subplot(2,1,1);hold on; plot(x_eval,slope*x_eval+intercept,'r');

[slope intercept] = fitLine( intercept_result );
figure(3);subplot(2,1,2);hold on; plot(x_eval,slope*x_eval+intercept,'r');

% 
% for col = 1:cols
% 
%     mean_res = median(plane_results(find(plane_results(:,2)==col),:));
% 
%     figure(4);
%     hold on;
%     subplot(2,1,1);
%     hold on;
%     %plot(plane_results(:,1),plane_results(:,2),'b.');
%     plot(col,mean_res(3),'b.');
%     title('Slope vs Column Values');
%     
%     subplot(2,1,2);
%     hold on;
%     plot(col,mean_res(4),'b.');
%     %plot(plane_results(:,1),plane_results(:,3),'b.');
%     title('Intercept vs Column Values');
% end;=======
