/*
 *  Minimal interface to PTU (modified Player int code)
 */

#ifndef __PTU46_MINI
#define __PTU46_MINI

//serial defines
#define PTU46_DEFAULT_BAUD B9600
#define PTU46_BUFFER_LEN 255

// command defines
#define PTU46_PAN 'p'
#define PTU46_TILT 't'
#define PTU46_MIN 'n'
#define PTU46_MAX 'x'
#define PTU46_MIN_SPEED 'l'
#define PTU46_MAX_SPEED 'u'
#define PTU46_VELOCITY 'v'
#define PTU46_POSITION 'i'

#define PTU46_BLOCK 1
#define PTU46_NOBLOCK 0

#define PTU46_PORTNAME "/dev/ttyUSB0"

typedef struct PTU46_data {
  int tmin;
  int tmax;
  int pmin;
  int pmax;
  float rtilt;
  float rpan;
} PTU46_data;

int PTU46_Write(int fd,char * data, int length);
int PTU46_Init(char *port,char **bufferp,PTU46_data **ptu_params);
int PTU46_ReadParams(int fd,char *buffer,PTU46_data *ptu_params);
int PTU46_PrintParams(PTU46_data *ptu_params);
int PTU46_Release(int fd,char *buffer,PTU46_data *ptu_params);
char *PTU46_Request(int fd,char *buffer,char *cmd);
float PTU46_GetRes(int fd,char *buffer,char type);
float PTU46_GetPos(int fd,char *buffer,PTU46_data *ptu_params,char type);
float PTU46_GetLimit(int fd,char *buffer,PTU46_data *pars,
		     char type, char LimType);
int PTU46_SetPos(int fd,char *buffer,PTU46_data *ptu_params,
		 char type, float pos, int Block);
int PTU46_SetPanTilt(int fd,char *buffer,PTU46_data *ptu_params,
		     float pan,float tilt,int Block);

#endif /* __PTU46_MINI */
