function path = buildGridPath(parents,start,goal)
% Build a path from start to goal as a series of grid cell
% locations from the parents map returned by gridAStar
%

current = goal;
i=1;
% Store the path backwards from the goal
while(current(1) ~= start(1) || current(2) ~= start(2) )
  path(i,:) = current;
  current = [ parents(current(1),current(2),1) parents(current(1),current(2),2)];
  i = i+1;
end;
path(i,:) = current;

% Simplify the path and reverse it
path = path(1:3:end,:);
path = path(end:-1:1,:);
