function [graphPath,graphDist] = buildMST( map, start, goal )

Distance=bitmax;
[height width] = size(map);
N = height * width;

for i=1:N
	graphDist(i) = bitmax;
	graphPath{i} = [];
end;

remaining=1:N;

graphDist(start)=0;
graphPath{start}=start;

while 1
   
	% find the cheapest node to reach from the current tree

	Distance = bitmax;
	shortestNode = -1;

	for i=remaining
		if graphDist(i) < Distance
			Distance = graphDist(i);
			shortestNode = i;
		end;
	end;
	
	remaining=[remaining(1:find(remaining==shortestNode)-1) remaining(find(remaining==shortestNode)+1:length(remaining))];

	% update the distances to unexplored nodes as necessary
	
	for i=remaining

		if( links(i,shortestNode) == 1 )

					pathDist = d(i,shortestNode);

					if graphDist(i) > graphDist(shortestNode) + pathDist

						graphDist(i) = graphDist(shortestNode) + pathDist;
						graphPath{i} = [ graphPath{shortestNode} ; i ];
					end;
		end;
	end;
end;