% Function gridFindNewReachableNeighbors grabs 8-connected neighbors in the
% grid and throws out those which are already in the closed list. 

% INPUTS: 
% origRow, origCol is the cell whose neighbors are requested
% height, width are the grid sizes
% closed is a 2-vector of rows and cols that are already considered

% OUTPUTS:
% neighbors is a 2-vector of neighboring rows and cols with the 
% point they are adjacent to

function neighbors = gridFindNewReachableNeighbors( origRow, origCol, height, width, closed, open )

    neighbors = [];
        
    for col = max(origCol-1,1):min(origCol+1,width)
       for row = max(origRow-1,1):min(origRow+1,height)
          if ( origRow ~= row || col ~= origCol )  &&...
               isempty(find(closed(:,1)==row & closed(:,2)==col)) &&...
               isempty(find(open(:,3)==row & open(:,4)==col))
           
                neighbors = [ neighbors; [ row col ] ];
          end;
       end;
   end;
