% Function gridFindReachableNeighbors grabs 8-connected neighbors in the
% grid

% INPUTS: 
% - origRow, origCol are the cell whose neighbors are requested
% - height, width are the grid sizes

% OUTPUTS
% - neighbors is the list of cells which are neighbors: a 2-vector of
% row, columns

function neighbors = gridFindReachableNeighbors( origRow, origCol, height, width )

    neighbors = [];
    
    for col = max(origCol-1,1):min(origCol+1,width)
       for row = max(origRow-1,1):min(origRow+1,height)
           if row ~= origRow || col ~= origCol
              neighbors = [ neighbors; [ row col] ];
           end;
       end;
    end;