clear all;
close all;
clc;


figure(1);
%imageName = 'sampleMap.bmp';
imageName = 'map3.pgm'; % Start and end values (95,155) and (105,185) work nicely with this map
%imageName = 'map2.pgm';
%map = rgb2gray(imread(imageName));
map = imread(imageName);
%map = imresize(map,0.2);

imagesc(map);
hold on;

% Threshold map so only true obstacles look like obstacles
obstacle_map = im2bw(map,0.9);
figure(11);
imagesc(obstacle_map);
title('Obstacles');

obstacle_map = 1-imdilate(1-obstacle_map,strel('disk',6));

% Distance transform, calculate distance to obstacle for every point
dist_map = bwdist(~obstacle_map);

obs_indices = find(dist_map==0);

% Scale the values so that obstacles are never touched, and free space is
% highly encouraged.
max_val = max(max(map));
map = 1000 / max_val .* ( max_val - map );

imagesc(dist_map);

scaled_im = 1./(dist_map+ 1).^2 + 10;
imagesc(scaled_im);

scaled_im(obs_indices) = INTMAX('int32');

figure(2);
imagesc(scaled_im);
hold on;
title('Planning Cost Function');

[height width junk] = size(map);

%map.pgm Values
start = [85 140];%[95 155];
goal = [100 190];%[ 117 173];

% %map2.pgm Values
% start = [90 150];
% goal = [ 124 185];


% Draw the start and goal nodes
plot(start(2),start(1),'ko');
plot(goal(2),goal(1),'ko');
 
[ dist parents ] = gridAStar( int32(scaled_im), int32(start), int32(goal) );
current = goal;

% Plot the path backwards from the goal
if dist(goal(1),goal(2)) < 16384
path = buildGridPath(parents,start,goal);
pSize = size(path);
figure(1);
for i=1:pSize(1)
    plot(path(i,2),path(i,1),'k.');
end;
end;
