%function bbox=bbox_from_conic(mvec)
%
% MVEC  Moment vector list 6xN, with each
%       column of the form [a x y x2 xy y2];
%
% BBOX  is a 4xN matrix of the form
%       [ymin xmin ymax xmax];
%
%Per-Erik Forssen, June 2004
function bbox=bbox_from_conic(mvec)

Nb=size(mvec,2);
bbox=zeros(4,Nb);

for k=1:Nb,
  mv=mvec(:,k);
  [E,D]=eig(mv([4 5;5 6]));
  D=2*sqrt(diag(D));  % r=2*sqrt(lambda)
  % Find maximum extent in each direction
  xmax=sqrt((D(1)*E(1,1))^2+(D(2)*E(1,2))^2);
  ymax=sqrt((D(1)*E(2,1))^2+(D(2)*E(2,2))^2);
  bbox(:,k)=[mv(3)-ymax mv(2)-xmax mv(3)+ymax mv(2)+xmax]';
end
