function params = depthModifiedSaliencyParams(depthImage,inputImage )
% depthModifiedSaliencyParams - returns a modified parameter vector which
% will pass the disparity image to further processing.
%
% depthImageFile is the name of the file containing the depth image
%
% File created by David Meger, March 6, 2007
%
%

% The first section deals with setting up the standard parameters for the
% Saliency Toolbox so that the non-depth features will be treated in the
% standard way:

declareGlobal;

% initialize the Image structure if necessary
if (isa(inputImage,'struct'))
  img = inputImage;
else
  img = initializeImage(inputImage);
end

params = defaultSaliencyParams(img.size,'dyadic');

% Now, add some information regarding to depth:

% Add the new feature type along with its weight
params.features{length(params.features)+1} = 'Depth';
params.weights = [ params.weights 5 ];

% Also, pass the disparity image, in the form required by the toolbox

params.depthImage = initializeImage(depthImage);