%function mvec=mvec_upsample(mvec0,csc)
%
% Convert MVEC to a higher resolution
% 
% CSC   Scale upsampling from (e.g. 2 for 2x size,3 for 4x etc)
%
%Per-Erik Forssen March 2007
function mvec=mvec_upsample(mvec0,csc)

if nargin<2,csc=2;end

mvec=mvec0;

k0=exp(log(4.0)*(csc-1.0));
k1=exp(log(2.0)*(csc-1.0));
k2=-(k1-1.0)/2.0;
  
mvec(1,:)=mvec(1,:)*k0;
mvec(2,:)=mvec(2,:)*k1+k2;
mvec(3,:)=mvec(3,:)*k1+k2;
mvec(4,:)=mvec(4,:)*k0;
mvec(5,:)=mvec(5,:)*k0;
mvec(6,:)=mvec(6,:)*k0;
