%%%%
%% A simple script which reads raw colour left/right images and calls the 
%% triclops library to get the colour rectified images.
%%
%% David Meger - March 2007
%%%%

close all;
clear all;
clc;

silent = true;

directory = '/lci/project/raid1/srvc/bumblebee1';

fileList = dir(directory);

validCounter = 0;

for i=1:length(fileList)
    fname = sprintf('%s/%s',directory,fileList(i).name);

    if ~isempty(strfind(fname, 'leftRect')) || ~isempty(strfind(fname, 'rightRect'))
        fprintf(1,'%s\n',fname);

        configFile = 'bb_id5020143.config';

        il = imread(fname);
        
        if ~silent
            subplot(2,1,1);
            imshow(il);
        end;

        [il]=colour_rectify(il,configFile);
        
        if ~silent
            subplot(2,1,2);
            imshow(il);
        end;

        fname = sprintf('data/%s_rect.png',fileList(i).name(1:strfind(fileList(i).name, '_')+1));
        imwrite(il,fname,'PNG');
    end;
end;
