/*
** mexutil.c
*/

#include <math.h>
#include <stdlib.h>
#include <string.h>
#include "mex.h"
#include "mexutil.h"

/*
** Function to check wether an argument is
** of proper class and size
** -1 as size means any size
*/
#define SSTR_SIZE 30
int type_check(char *pname,const mxArray *arg,mxClassID classid,int mdims,int *msize)
{
const int *dims;
 const char *classidl[]={"double","int","uint8","other"};
 char sstr[SSTR_SIZE+1];
 int k,retval;
  dims = mxGetDimensions(arg);
  retval=1;
  if(mxGetClassID(arg) != classid) {
    switch(classid) {
    case mxDOUBLE_CLASS:
      k=0;break;
    case mxINT32_CLASS:
      k=1;break;
    case mxUINT8_CLASS:
      k=2;break;
    default:
      k=3;
    }
   mexPrintf("Type mismatch: <%s> should be of class %s.\n",pname,classidl[k]);
    retval=0;
  }
  if(mxGetNumberOfDimensions(arg) != mdims) {
    mexPrintf("Type mismatch: <%s> should be %dD.\n",pname,mdims);
     retval=0;
  }
  if(retval) {
    for(k=0;k<mdims;k++) {
      if((msize[k] != -1) && (dims[k] != msize[k])) retval=0;
    }
    if(!retval) {
      strncpy(sstr,"proper size",SSTR_SIZE);
      if((mdims==2)&&(msize[0]==1)&&(msize[1]==1))
	strncpy(sstr,"scalar",SSTR_SIZE);
      if((mdims==2)&&(msize[0]>0)&&(msize[1]>0))
	sprintf(sstr,"%dx%d",msize[0],msize[1]);
      if((mdims==3)&&(msize[0]>0)&&(msize[1]>0)&&(msize[2]>0))
	sprintf(sstr,"%dx%dx%d",msize[0],msize[1],msize[2]);
      mexPrintf("Type mismatch: <%s> should be %s.\n",pname,sstr);
    }
  }
  return retval;
}
