/*
**  bayer.h
**
**  Routines for interpolating a Bayer-sensor pattern to
**  a Matlab RGB image.
*/
#ifndef __BAYER
#define __BAYER

#include <stdio.h>
#include <time.h>
#include "image_buffer.h"

/* Enumeration of Bayer patterns */
enum {BAYER_BGGR,
      BAYER_GRBG,
      BAYER_RGGB,
      BAYER_GBRG};
  
void write_time_diff(char *strg,clock_t t0,clock_t t1);

void bayer_to_rgb(unsigned char *field_ptr,buffer *bf_rgb,int bpattern);

void bayer_to_rgb_fields(unsigned char *field_ptr,buffer *bf_rgb,int bpattern,int fields,int field);

void bayer_to_rgb_stereo16(unsigned char *field_ptr,buffer *bf_rgb,int bpattern,int field);

void bayer_to_rgb_ds(unsigned char *field_ptr,buffer *bf_rgb,int bpattern);

void bayer_to_rgb_fields_ds(unsigned char *field_ptr,buffer *bf_rgb,int bpattern,int fields,int field);

void bayer_to_rgb_stereo16_ds(unsigned char *field_ptr,buffer *bf_rgb,int bpattern,int field);

#endif /* __BAYER */
