function res = draw_rect(inrct, linwid, lincol, res)

% res = draw_rect(inrct, linwid, lincol, res)
%
% Draws a rectangle with the specified linewidth and color in 'res'
%
% RES    The image to draw in
% INRCT  The rectangle to draw
% LINWID The line width to use
% LINCOL The color to draw with
%
%  Author: Johan Wiklund, jowi@isy.liu.se
%

Ms = inrct(1);
Ns = inrct(2);
Me = inrct(3);
Ne = inrct(4);

P1 = [Ns Ne Ne Ns; Ms Ms Me Me];
P2 = [Ne Ne Ns Ns; Ms Me Me Ms];
res = paint_lines(res, P1, P2, linwid, lincol);
