%function [Im,cm]=paint_labels(Limg,cm)
%
%  Generate an RGB image with
%  labels painted in random colours.
%  If a colour map is supplied it is used,
%  otherwise a new random one is generated.
%  Label 0 is always black.
%
% LIMG   Input label image
% CM     Colour map (need not be supplied)
%
%Per-Erik Forssen, Dec 2006
function [Im,cm]=paint_labels(Limg,cm)

if nargin<2,cm=rand(256,3);cm(1,:)=0;end

[rows,cols]=size(Limg);
Im=zeros(rows,cols,3);
L2=mod(Limg,254)+2;
L2(Limg==0)=1;
for k=1:3,
  Im(:,:,k)=reshape(cm(L2,k),[rows cols]);
end
