%function Im=paint_lines(Im0,P1,P2,width,col)
%
% Draw lines with sub-pixel located end points
% in an RGB image.
%
% IM0    Image to draw in (ROWSxCOLSx3)
% P1,P2  Line end point lists [x;y]
% WIDTH  Line width (default 1.0)
% COL    RGB vector (3x1) default [1 0 0]
%
%Per-Erik Forssen, May 2004
function Im=paint_lines(Im0,P1,P2,width,col)

if nargin<5,col=[1 0 0];end
if nargin<4,width=1.0;end

[rows,cols,ndim]=size(Im0);
if ndim==1;
  Im=repmat(Im0,[1 1 3]);
else
  Im=Im0;
end

mask=draw_lines(zeros(rows,cols),P1,P2,width);
nmask=1-mask;

Im=reshape([Im(:,:,1).*nmask+mask*col(1) ...
	    Im(:,:,2).*nmask+mask*col(2) ...
	    Im(:,:,3).*nmask+mask*col(3)],[rows cols 3]);
