%function h=plot_hlines(L,imbox)
%
% Plot a set of lines l_k=[l1 l2 l3]', for
% which l_k'*[x y 1]'=0;
% L     Matrix with lines in columns (3xN)
% IMBOX image bounding box [yl yh xl xh]
%
%Per-Erik Forssen, Jan 2004

function h=plot_hlines(L,imbox)

Nl=size(L,2); % Number of lines

h=zeros(Nl,1);
for k=1:Nl,
  %l=F*[P(k,:) 1]';
  l=L(:,k);
  m=[0 0 0 0];      % yl yh xl xh
  if(l(1)~=0)
    x1=-(l(2)*imbox(1)+l(3))/l(1);
    if((x1<imbox(4))&(x1>imbox(3))) m(1)=1;end
    x2=-(l(2)*imbox(2)+l(3))/l(1);
    if((x2<imbox(4))&(x2>imbox(3))) m(2)=1;end
  end
  if(l(2)~=0)
    y1=-(l(1)*imbox(3)+l(3))/l(2);
    if((y1<imbox(2))&(y1>imbox(1))) m(3)=1;end
    y2=-(l(1)*imbox(4)+l(3))/l(2);
    if((y2<imbox(2))&(y2>imbox(1))) m(4)=1;end
  end
  switch([8 4 2 1]*m')
   case 12,
    h(k)=plot([x1 x2],[imbox(1) imbox(2)]);
   case 10,
    h(k)=plot([x1 imbox(3)],[imbox(1) y1]);
   case 9,
    h(k)=plot([x1 imbox(4)],[imbox(1) y2]);
   case 6,
    h(k)=plot([x2 imbox(3)],[imbox(2) y1]);
   case 5,
    h(k)=plot([x2 imbox(4)],[imbox(2) y2]);
   case 3,
    h(k)=plot([imbox(3) imbox(4)],[y1 y2]);
   otherwise
    disp('WARNING:Line falls outside image.');
    m
  end
end
h=h(h>0);
