%function [h = ] plot_moments(mvec,lw,col)
% or function [h = ] plot_moments(mvec,lw,pvec)
% Visualise a list of moments
%
% MVEC   Moment list
% LW     Line width for ellipses (default 0.5)
% COL    Colour string (default 'r')
% PVEC   list of RGB triplets
%
%Per-Erik Forssen, Feb 2003

function h=plot_moments(mvec,lw,col)

if nargin<2,lw=0.5;end
if nargin<3,col='r';end

Nbl=size(mvec,2);
h=zeros(Nbl,1);
if isa(col,'char'),
  for k=1:Nbl,
    m=mvec(2:3,k);
    I=reshape(mvec([4 5 5 6],k),[2 2]);
    h(k)=plot_ellipse(m,I,lw,col);hold on
  end
else
  if all(size(col)==[3 Nbl]),
    for k=1:Nbl,
      m=mvec(2:3,k);
      I=reshape(mvec([4 5 5 6],k),[2 2]);
      h(k)=plot_ellipse(m,I,lw,col(:,k));hold on
    end    
  end
end

if(nargout==0),clear h;end