%
% Simple script to set white balance of bumblebee
%

subsamplefl=1;   % Set to 0 for hires, 1 for lowres

% Read from camera sensor
camera('connect',1);

vm=camera('video_mode');
if(sum(vm=='7'))
  bayer_pattern=0; % BGGR  (for BB-HICOL-40)
  wb_ub=50;   % Default white-balance settings
  wb_vr=32;
else
  bayer_pattern=2; % RGGB (for BB-COL-40)
  wb_ub=53;
  wb_vr=41;
end

% Check how many fields there are
bayerflag=1;fields=0;
if(length(strfind(vm,'MONO'))) fields=1;end
if(length(strfind(vm,'MONO16'))) fields=2;end
if(length(strfind(vm,'RGB'))) fields=3;end
if(fields==0) 
  bayerflag=0;dcamtype=0;
  if(length(strfind(vm,'YUV444'))) dcamtype=2;end
  if(length(strfind(vm,'YUV422'))) dcamtype=3;end
  if(length(strfind(vm,'YUV411'))) dcamtype=4;end
end
camera('setup_capture',1);

[wb_ub,wb_vr]=camera('whitebalance',wb_ub,wb_vr);

loopfl=1;
while(loopfl)
  a=camera('getframe'); % Grab twice to make sure change has gone through
  a=camera('getframe');

  if(bayerflag)
    il=bayer2rgbstereo(a,subsamplefl,bayer_pattern,fields);
  else
    il=dcam2rgb(a,dcamtype);
  end
  
  figure(1);clf
  subplot(1,2,1);
  plot(wb_ub,wb_vr,'ro');
  axis image;
  axis([0 64 0 64]);
  grid on
  xlabel('ub');
  ylabel('vb');
  title('Right click to exit.')
  
  subplot(1,2,2);
  image(il);axis image
  title(['Current: ub=' num2str(wb_ub) ' vr=' num2str(wb_vr)]);
  drawnow
  
  [x,y,b]=ginput(1);
  if b==3,loopfl=0;end
  
  if loopfl,
    wb_ub=x;
    wb_vr=y;
    [wb_ub,wb_vr]=camera('whitebalance',wb_ub,wb_vr);
  end
end
fprintf('Done. Final settings: ub=%d vr=%d\n',wb_ub,wb_vr);

camera('stop_capture');
camera('disconnect');
